Status: Rejected Priority: Low
Author: artart78 Category: Build
Created: 05/08/2010 Assignee:
Subject: Parse error problem for config files on linux when regenerating the bison/flex script file
Description

You must not generate the cf_* file in code\nel\src\misc\config_file because it's known to not working anymore with current version of
flex and bison.

Use the generated file that are in the repo.

History
#1 - 05/08/2010 07:35 pm - artart78

It seems to work now. The parser files from the repo seem correct; I think it messed them up when I ran cmake (before running the make_all). You can
close it, except if you think there's a problem in the CMakeFiles.

#2 - 05/09/2010 08:04 pm - zorglub

I also had some problems with the config file parser. Basically, nothing worked, not even the sample, not even an empty file.

I finally nailed it down to the following problem, in nel/src/misc/config_file/cf_grammatical.h
Here, we statically define the tokens for use by the lexer, starting at 257.
However, the parser (cf_grammatical.cpp) starts at 258.

So for example, we have in cf_grammatical.h:

#define ADD_ASSIGN      257

And in cf_grammatical.cpp:

ADD_ASSIGN = 258,

Which causes tokens sent from the lexer to be misinterpreted by the parser, wrecking havoc.

I guess some behaviour changed in flex/bison, somewhere. I run Gentoo 64 bits, with the following versions:

bison (GNU Bison) 2.4.1

flex 2.5.35

#3 - 05/09/2010 08:14 pm - zorglub
After a bit more look, it might be a slight build discrepancy somewhere. In my case, the parser (cf_grammatical.cpp) is regenerated by the build
process (in the build root, code/build/release/nel), whereas it seems that it's not intended. The src commited one (in code/nel/src/) is apparently
supposed to be used and has the defines for the symbols.

#4 - 05/12/2010 03:04 am - krystlih

I have this issue on Ubuntu 10.04 32-bit right now, I've tried using both versions of the cf_grammatical.cpp file with no luck, does anyone have a
resolution to this issue?

#5 - 05/15/2010 03:23 am - TiXx815

same problem on Ubuntu 10.04 64-bit and bison 2.4.1 right now

#6 - 05/15/2010 08:54 pm - rti

http://dev.ryzom.com/boards/17/topics/1613#message-1737

#7 - 05/17/2010 03:24 pm - vl
- Subject changed from Parse error problem for config files on linux to Parse error problem for config files on linux when regenerating the bison/flex 
script file
- Status changed from New to Validated
- Priority changed from Normal to Low

I changed the title and text since we know we must not regenerate the script file

#8 - 09/15/2010 09:53 am - kervala

With flex 2.5.4 and bison 2.4.1, that's working fine and even if some #defines are not identical to before, it doesn't create any bug.

#9 - 09/15/2010 09:54 am - kervala
- Status changed from Validated to Rejected
- Target version set to Version 0.8.0
